import 'iconfont_model.dart';
import 'package:dart_style/dart_style.dart';

class IconfontConfig {
  static String yamlPath = 'pubspec.yaml';
  static String saveYamlPath = "pubspec.yaml.g";

  static String readPath = 'assets/fonts/';
  static String writePath = 'lib/icons/';

  static getIconFontTemp(IconFontModel iconFontModel, String className) {
    String itemContents = "";
    for (IconFontModelGlyphs glyph in iconFontModel.glyphs) {
      String preName = iconFontModel.cssPrefixText ?? "";
      String iconName = glyph.fontClass;

      itemContents += """
static const IconData  ${formatName("$preName$iconName")}= IconData(0x${glyph.unicode}, fontFamily: _family); //  ${glyph.name}
""";
    }

    String contents = '''
//  This file is automatically generated. DO NOT EDIT, all your changes would be lost.
//  https://pub.dartlang.org/packages/iconfont

import 'package:flutter/material.dart' show IconData;

class $className {
static const String _family = '${iconFontModel.fontFamily}';
	
$className._();

$itemContents
}
''';

    var formatter = new DartFormatter(pageWidth: 200);

    try {
      contents = formatter.format(contents);
    } on FormatterException catch (ex) {
      print(ex);
    }

    return contents;
  }

  static formatName(String str) {
    return str.replaceAll('-', '_').split("_").map((e) => e.isNotEmpty ? _capitalize(e) : "").join("");
  }

  static String _capitalize(String str) {
    return "${str[0].toUpperCase()}${str.substring(1)}";
  }
}
